#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "assert.h"
#include "vector.h"
#include "vectorrep.h"

#define T Vector_T

T
Vector_new (int length) {
  T vector = malloc(sizeof(*vector));
  
  vector->length = length;
  vector->elements = (double *) calloc(length,sizeof(double));
  return vector;
}

void
Vector_free (T *vector) {
  free((*vector)->elements);
  free(*vector);
}


int
Vector_length (T vector) {
  return vector->length;
}

int
Vector_size (T vector) {
  return vector->size;
}

double
Vector_get (T vector, int i) {
  return vector->elements[i];
}

void
Vector_put (T vector, int i, double elt) {
  vector->elements[i] = elt;
}

double
Vector_sum (T vector) {
  double sum = 0.0;
  int i;

  for (i = 0; i < vector->length; ++i) {
    sum += vector->elements[i];
  }
  return sum;
}

void
Vector_intprint (T vector) {
  int i;

  for (i = 0; i < vector->length; ++i) {
    printf("%3d ", (int) Vector_get(vector,i));
  } 
  printf("\n");
}


void
Vector_doubleprint (T vector) {
  int i;

  for (i = 0; i < vector->length; ++i) {
    printf("%.4f ",Vector_get(vector,i));
  }
  printf("\n");
}

