#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "entry.h"

#define T Entry_T
struct Entry_T {
  char *name;
  int namelen;
  int start;
  int end;
  double significance;
  char *hit;
};


static void
string_copy (char *s, char *t) {
  while ((*s++ = *t++) != '\0') ;
}

T
Entry_new (char *name, int start, int width,
	   double significance, char *hit) {
  T entry = (T) malloc(sizeof(*entry));
  
  entry->name = (char *) calloc(strlen(name)+1,sizeof(char));
  string_copy(entry->name,name);
  entry->start = start;
  entry->end = start + width;
  entry->significance = significance;
  entry->hit = (char *) calloc(width+1,sizeof(char));
  string_copy(entry->hit,hit);
  return entry;
}
  
void
Entry_free (T *entry) {
  free((*entry)->hit);
  free((*entry)->name);
  free(*entry);
}

int
Entry_start (T entry) {
  return entry->start;
}

int
Entry_end (T entry) {
  return entry->end;
}

double
Entry_significance (T entry) {
  return entry->significance;
}

char *
Entry_name (T entry) {
  return entry->name;
}

char *
Entry_hit (T entry) {
  return entry->hit;
}

int
Entry_cmp (const void *x, const void *y) {
  T entry1, entry2;

  entry1 = * (Entry_T *) x;
  entry2 = * (Entry_T *) y;

  if (entry1->significance > entry2->significance) {
    return 1;
  } else if (entry1->significance < entry2->significance) {
    return -1;
  } else {
    return 0;
  }
}


void
Entry_print (T entry) {
  printf("%.2e|%s|",entry->significance, entry->name);
  printf("%s|%d|%d\n",
	 entry->hit,(entry->start)+1,entry->end);
}
