#ifndef DIST_INCLUDED
#define DIST_INCLUDED
#include "bool.h"


#define T Dist_T
typedef struct T *T;

extern T
Dist_init ();
extern T
Dist_new (int min_score, int max_score);
extern void
Dist_free (T *dist);
extern int
Dist_min_score (T dist);
extern int
Dist_max_score (T dist);
extern double
Dist_get_prob (T dist, int score);
extern void
Dist_add_prob (T dist, int score, double prob);
extern void
Dist_add_dist (T new, T dist);
extern void
Dist_print (T dist);
extern void
Dist_print_steps (T dist, int fromsig, int tosig);
extern void
Dist_print_probs (T dist, bool continuous);
extern void
Dist_print_threshold (T dist, double p_threshold, bool continuous);
extern double
Dist_check (T dist);



#undef T
#endif

